
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Pos_terminalsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pos_terminals = await db.pos_terminals.create(
            {
                id: data.id || undefined,
        
        terminal_number: data.terminal_number
        ||
        null
            ,
            
        merchant_number: data.merchant_number
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await pos_terminals.setBusiness( data.business || null, {
            transaction,
        });
        
        await pos_terminals.setBank_account( data.bank_account || null, {
            transaction,
        });
        

        

        

        return pos_terminals;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const pos_terminalsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                terminal_number: item.terminal_number
            ||
            null
            ,
            
                merchant_number: item.merchant_number
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const pos_terminals = await db.pos_terminals.bulkCreate(pos_terminalsData, { transaction });

        // For each item created, replace relation files
        

        return pos_terminals;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const pos_terminals = await db.pos_terminals.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.terminal_number !== undefined) updatePayload.terminal_number = data.terminal_number;
        
        
        if (data.merchant_number !== undefined) updatePayload.merchant_number = data.merchant_number;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await pos_terminals.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await pos_terminals.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        
        if (data.bank_account !== undefined) {
            await pos_terminals.setBank_account(
              
              data.bank_account,
              
              { transaction }
            );
        }
        

        
        

        

        return pos_terminals;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pos_terminals = await db.pos_terminals.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of pos_terminals) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of pos_terminals) {
                await record.destroy({transaction});
            }
        });


        return pos_terminals;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const pos_terminals = await db.pos_terminals.findByPk(id, options);

        await pos_terminals.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await pos_terminals.destroy({
            transaction
        });

        return pos_terminals;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const pos_terminals = await db.pos_terminals.findOne(
            { where },
            { transaction },
        );

        if (!pos_terminals) {
            return pos_terminals;
        }

        const output = pos_terminals.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await pos_terminals.getBusiness({
            transaction
        });
        
        
        output.bank_account = await pos_terminals.getBank_account({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              trade_name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.bank_accounts,
        as: 'bank_account',
        
        where: filter.bank_account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.bank_account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_title: {
                [Op.or]: filter.bank_account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.terminal_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pos_terminals',
                        'terminal_number',
                        filter.terminal_number,
                    ),
                };
            }
            
            if (filter.merchant_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pos_terminals',
                        'merchant_number',
                        filter.merchant_number,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pos_terminals',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.pos_terminals.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'pos_terminals',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.pos_terminals.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

